<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="org.kxml.*" %>
<%@ page import="org.kxml.parser.*" %>
<%@ page import="org.kxml.kdom.*" %>
<%
  String count;

  // Get info from the XML document posted in the HTTP request.
  Reader reader = request.getReader();
  XmlParser parser = new XmlParser (reader);
  Document doc = new Document();
  doc.parse(parser);

  // Check the sessionID.
  String sid = ((Element) doc.getRootElement().getChild(0)).getAttribute("id").getValue();
  // Get the "count" attribute associated with the sessionID.
  Object o = pageContext.getAttribute(sid, PageContext.APPLICATION_SCOPE);
  // If the sessionID is not found, 
  // set count to zero and start a new session.
  if ( o == null ) {
    sid = Long.toString( (new Date()).getTime() );
    count = "0";
    pageContext.setAttribute(sid, count, PageContext.APPLICATION_SCOPE); 
  } else {
    count = (String) o;
  }
  // Increase count by one in every visit.
  count = Integer.toString(Integer.parseInt(count)+1);
  pageContext.setAttribute(sid, count, PageContext.APPLICATION_SCOPE); 

  // The following XML is send back to the client. 
  // The format is pre-agreed between the two parties.

  // ALL WHITE SPACES ARE SIGNIFICANT IN OUR XML DOCUMENTS! 
%>
<SessionWrapper><SessionID id="<%=sid%>"/><OriginalContent><Message>This is your <%=count%>th visit to this XML session envelop-enabled page.</Message></OriginalContent></SessionWrapper>
